#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define do_modifyname(yy,zz)	\
	for (x = 0; x < strlen(yy); x++) {		\
		if (yy[x] == '#') yy[x] = zz;	\
	}						\

int main(int argc, char **argv)
{
	char output[256];
	char name0[256];
	char countc[256];

	char nameA[128];
	char nameB[128];

	FILE *fa, *fb, *fo;

	int count;
	int i,j,x;

	if (argc < 3) {
		printf ("usage:\nunifyc name count\nname  -use # for where rom number should be (eg. 058-c#.c#)\ncount -number of roms (max 8)\n");
		return 1;
	}

	strcpy (name0, argv[1]);
	strcpy (countc,argv[2]);

	printf ("name0: %s\n", name0);

	if (strlen(countc) > 1) {
		printf ("only supports 8 roms max!\n");
		return 1;
	}

	count = countc[0] & 0x0f;

	if (count > 0x08) {
		printf ("Only supports 8 roms max!\n");
		return 1;
	}

	strcpy (output, name0);

	do_modifyname(output,'X')

	fo = fopen(output, "wb");

	for (i = 0; i < count; i+=2)
	{
		strcpy (nameA, name0);
		strcpy (nameB, name0);

		do_modifyname(nameA,(0x30+i+1))
		do_modifyname(nameB,(0x30+i+2))

		printf ("NameA: %s\nNameB %s\n", nameA, nameB);

		fa = fopen(nameA, "rb");

		if (fa == NULL) {
			printf ("%s not found!\n", nameA);
			return 1;
		}

		fb = fopen(nameB, "rb");

		if (fb == NULL) {
			printf ("%s not found!\n", nameB);
			return 1;
		}

		fseek (fa, 0, SEEK_END);
		int lenA = ftell (fa);
		rewind (fa);

		fseek (fb, 0, SEEK_END);
		int lenB = ftell (fb);
		rewind (fb);

		if (lenB != lenA) {
			printf ("%s does not equal %s size!\n", nameA, nameB);
		}

		if (lenB > lenA) lenA = lenB;

		unsigned char *tmp = (unsigned char*)malloc(lenA * 2);

		memset (tmp, 0, lenA * 2);

		for (j = 0; j < lenA * 2; j+=2)
		{
			fread (tmp + j + 0, 1, 1, fa);
			fread (tmp + j + 1, 1, 1, fb);
		}

		fwrite (tmp, lenA * 2, 1, fo);

		free (tmp);

		fclose (fa);
		fclose (fb);
	}

	printf ("Finished!\n");

	fclose (fo);
}
